/************************************************************************/
/*                                                                      */
/* Driver Name: QL4X00.SYS 										        */
/*                                                                      */
/* Source File Name: QLISIOLN.H                                         */
/*                                                                      */
/************************************************************************/
/*                                                                      */
/*                              NOTICE                                  */
/*                                                                      */
/*               COPYRIGHT 1996-2002 QLOGIC CORPORATION                 */
/*                        ALL RIGHTS RESERVED                           */
/*                                                                      */
/*     This computer program  is  CONFIDENTIAL  and a TRADE SECRET      */
/*     of  QLOGIC CORPORATION.  The  receipt  or possesion of this      */
/*     program does not convey any rights to reproduce or disclose      */
/*     its contents, or to manufacture, use, or sell anything that      */
/*     it may describe, in whole or in part, without the  specific      */
/*     written consent of QLOGIC CORPORATION.  Any reproduction of      */
/*     this program  without the express written consent of QLOGIC      */
/*     CORPORATION  is a violation  of the copyright laws  and may      */
/*     subject you to criminal prosecution.                             */
/*                                                                      */
/************************************************************************/

#ifndef _QLISIOLN_H_
#define _QLISIOLN_H_

#include <linux/ioctl.h>

#ifdef APILIB
#include <stdint.h>
#endif


#define	INT8	int8_t
#define	INT16	int16_t
#define	INT32	int32_t
#define	UINT8	uint8_t
#define	UINT16	uint16_t
#define	UINT32	uint32_t

#define UINT64  unsigned long long

#define BOOLEAN uint8_t


#if BITS_PER_LONG <= 32
#define EXT_ADDR_MODE_OS  EXT_DEF_ADDR_MODE_32
#else
#define EXT_ADDR_MODE_OS  EXT_DEF_ADDR_MODE_64
#endif


#define QLMULTIPATH_MAGIC 'y'

#define _QLBUILD   /* for qlisioct.h to enable include of qinsdmgt.h */



#define	EXT_DEF_MAX_HBA_OS		255	/* 0 - 0xFE */
#define	EXT_DEF_MAX_BUS_OS		1
#define	EXT_DEF_MAX_TARGET_OS		255	/* 0 - 0xFE */
#define	EXT_DEF_MAX_LUN_OS		255	/* 0 - 0xFE */

#define EXT_DEF_MAX_AEN_QUEUE_OS        64



/*****************/
/* Command codes */
/*****************/

/* These are regular command codes */

#define EXT_CC_QUERY_OS					/* QUERY */	\
    _IOWR(QLMULTIPATH_MAGIC, 0x00, sizeof(EXT_IOCTL_ISCSI))
	
#define EXT_CC_REG_AEN_OS				/* REG_AEN */ \
    _IOWR(QLMULTIPATH_MAGIC, 0x01, sizeof(EXT_IOCTL_ISCSI))

#define EXT_CC_GET_AEN_OS				/* GET_AEN */ \
    _IOWR(QLMULTIPATH_MAGIC, 0x02, sizeof(EXT_IOCTL_ISCSI))

#define EXT_CC_GET_DATA_OS				/* GET_DATA */ \
    _IOWR(QLMULTIPATH_MAGIC, 0x03, sizeof(EXT_IOCTL_ISCSI))

#define EXT_CC_SET_DATA_OS				/* SET_DATA */ \
    _IOWR(QLMULTIPATH_MAGIC, 0x04, sizeof(EXT_IOCTL_ISCSI))
	
#define EXT_CC_SEND_SCSI_PASSTHRU_OS	/* SCSI_PASSTHRU */ \
    _IOWR(QLMULTIPATH_MAGIC, 0x05, sizeof(EXT_IOCTL_ISCSI))

#define EXT_CC_SEND_ISCSI_PASSTHRU_OS	/* ISCSI_PASSTHRU */ \
    _IOWR(QLMULTIPATH_MAGIC, 0x06, sizeof(EXT_IOCTL_ISCSI))


/*
 * This is a Linux driver implementation specific command. 
 */

#define EXT_CC_GET_HBACNT				/* GET_HBACNT */ \
    _IOWR(QLMULTIPATH_MAGIC, 0xff, sizeof(EXT_IOCTL_ISCSI))


/* 
 * HBA Count  
 */
typedef struct _EXT_HBA_COUNT {
		UINT16	HbaCnt;									/* 2	*/
} EXT_HBA_COUNT, *PEXT_HBA_COUNT;	   					/* 2    */


#endif //_QLISIOLN_H_
